/*
Gabriel Riberti de Siqueira
Nº USP 3531700

Trabalho FInal da Disciplina PCS-2290 - Fundamentos da Informática II
JOGO "COMBINELETRA"

*/

int inicial = int(random(1, 3.5));       /* indica por qual palavra comecamos                                           */
int quadX = 50;                          /* Posicao, para desenhar os quadrados brancos                                 */ 
int quadY = 80;
String[] banco = iniciaBancoPalavras();  /* banco de palavras usadas                                                    */
String nomeFonte = "Serif-60.vlw";       /* nome da fonte usada                                                         */
char [] embaralhado = new char[8];       /* ordem das letras embaralhadas                                               */
char [] resposta = new char[0];          /* ordem das letras usadas na resposta                                         */
int [] clicados = new int[8];            /* vetor de flags indica se a letra daquela posicao ja foi clicada recentemente*/
int [] correspondentes = new int[8];     /* vetor que indica a posicao de onde a letra na resposta veio originalmente   */
int posicaoAtual = 0;                    /* indica a posicao que a letra clicada deve entrar na resposta                */
int contaPalavra = 1;                    /* conta em qual palavra esta o jogador                                        */

void setup() {
size (800, 600);
background(0);
noStroke();
fill(255);
smooth();
// Inicializa os vetores 
for(int i = 0; i < 8; i++) {
  clicados[i] = 0;  
  correspondentes[i] = 0;
}
PImage fundo;

// carrega o fundo de telas
fundo = loadImage("esquema-tori.jpg");   
background(fundo);
// desenha os quadrados de fundo 
iniciaPalavra();
// desenha a maior palavra com as letras embaralhadas
 carregaPalavra();

}

void draw() {  
 // testa o clique do mouse para saber se a pessoa estah jogando;
  apertouMouse();
  }

// Funcao que testa se o jogador clicou em algum determinado botao
void apertouMouse() {
 if(mousePressed) {
   if(mouseY >= 440 && mouseY <= 500) {
    if(mouseX >= 50 && mouseX <= 115) {
     letra(0);
    } 
    if(mouseX >= 120 && mouseX <= 185) {
     letra(1);
    } 
    if(mouseX >= 190 && mouseX <= 255) {
     letra(2);
    } 
    if(mouseX >= 260 && mouseX <= 325) {
     letra(3);
    } 
    if(mouseX >= 330 && mouseX <= 395) {
     letra(4);
    } 
    if(mouseX >= 400 && mouseX <= 465) {
     letra(5);
    }
    if(mouseX >= 470 && mouseX <= 535) {
     letra(6);
    } 
    if(mouseX >= 540 && mouseX <= 605) {
     letra(7);
    } 
  
   }
   
   if(mouseY >= 370 && mouseY <= 430) {
    if(mouseX >= 50 && mouseX <= 115) {
     apagaLetra(0);
    } 
    if(mouseX >= 120 && mouseX <= 185) {
     apagaLetra(1);
    } 
    if(mouseX >= 190 && mouseX <= 255) {
     apagaLetra(2);
    } 
    if(mouseX >= 260 && mouseX <= 325) {
     apagaLetra(3);
    } 
    if(mouseX >= 330 && mouseX <= 395) {
     apagaLetra(4);
    } 
    if(mouseX >= 400 && mouseX <= 465) {
     apagaLetra(5);
    }
    if(mouseX >= 470 && mouseX <= 535) {
     apagaLetra(6);
    } 
    if(mouseX >= 540 && mouseX <= 605) {
     apagaLetra(7);
    } 
  
   }
   
   
   if(mouseY >= 520 && mouseY <= 550 && mouseX >= 50 && mouseX <= 220) {
     pularPalavra();
    }
   if(mouseY >= 390 && mouseY <= 420 && mouseX >= 640 && mouseX <= 750) {
      enviar();
     }
   if(mouseY >= 460 && mouseY <= 490 && mouseX >= 640 && mouseX <= 750) {
      embaralhar(); 
   } 
    
 }
}

// Clicou em alguma letra, o i eh da esquerda pra direita, comecando do 0 indo ate o 7 indica a posicao da letra
void letra(int i) {
  if(clicados[i] != 1) {
    resposta = append(resposta, embaralhado[i]); // coloca na resposta a letra clicada
    clicados[i] = 1; // marca a letra como clicada recentemente
    fill(0);
    quad(56 + (70*i), 443, 112+(70*i), 443, 112+(70*i), 498, 56+(70*i), 498); // apaga o local onde a letra estava
    PFont fonte= loadFont(nomeFonte);
    textFont(fonte,60);
   fill(255); 
  text(embaralhado[i], 64 + (posicaoAtual*70), 421);  // coloca a letra na resposta
  correspondentes[posicaoAtual] = i; // marca no vetor de correspondentes a posicao de onde a letra veio
  posicaoAtual++; // incrementa a posicao, para marcar a nova posicao atual
  }
}

// semelhante a funcao anterior, apaga a letra da resposta, APENAS SE FOR A ULTIMA LETRA DA RESPOSTA
void apagaLetra(int i) {
  if(posicaoAtual == i+1) {
    clicados[correspondentes[i]] = 0; // limpa o clicado recentemente
    resposta = shorten(resposta); // tira a letra da resposta
    fill(0);
    quad(56 + (70*i), 373, 112+(70*i), 373, 112+(70*i), 428, 56+(70*i), 428); // apaga a letra na tela de resposta
    PFont fonte= loadFont(nomeFonte);
    textFont(fonte,60);
   fill(255); 
  text(embaralhado[correspondentes[i]], 64 + (correspondentes[i]*70), 491); // volta a imprimir a letra no vetor embaralhado
       correspondentes[i] = 0; // desmarca a correspondencia, pois a letra nao pertence mais a resposta
    posicaoAtual--; // volta a posicao anterior
  }
}



void pularPalavra() {
  contaPalavra++;
  if(contaPalavra > 3) {
    //Jogo terminou!!! 
  } else {
    
    // Limpa as variaveis que indicam o estado do jogo
    for(int i = 0; i < 8; i++) {
      clicados[i] = 0;  
      correspondentes[i] = 0;
    }
    posicaoAtual = 0;
    quadX = 50;
    quadY = 80;
    resposta = new char[0];
    
    // troca a palavra para a proxima
    inicial = (inicial + 1);
    if(inicial == 4) {
      inicial = 1; 
    }
    
    PImage fundo;

    // Recarrega o fundo de telas
      fundo = loadImage("esquema-tori.jpg");   
    background(fundo);
     banco = iniciaBancoPalavras();
    
    // desenha novamente os quadrados e carrega a nova palavra embaralhada
    iniciaPalavra();
   carregaPalavra();

  }
}

// Reembaralha as letras da palavra
void embaralhar() {
  apagar();
  carregaPalavra();
}

// Testa se a palavra pertence ao banco de palavras
void enviar() {
  String str = new String(resposta);
  int indice = 0, X, Y;
  boolean existe = false;
  for(int i = 0; i < tamBanco(); i++) {
  
    // Se a palavra bate com alguma do banco guarda o indice
    if(str.compareTo(banco[i]) == 0) {
      indice = i;
      existe = true;
      break;
    }
    
  }
  
  // Calcula a posicao que a palavra ocupa na tela
  X = 53;
  Y = 97;
  if(existe) {
  for(int i = 0; i < indice; i++) {
     Y = Y + 26;
     if(Y > 350) {
       if(X == 53) {
          X = 303; 
       } else {
          X = 563;
       }
       Y = 97;
     }
  }
  
  // Descoberta a posicao que a palavra ocupa, imprime a palavra no local desejado
  for(int i = 0; i < str.length(); i++) {
    PFont fonte= loadFont(nomeFonte);
    textFont(fonte,20);
    fill(0); 
    text(resposta[i], X + (i*24), Y); 
  }
  }
  
  // apaga a resposta anterior e reimprime a palavra embaralhada
  apagar();
  for(int i = 0; i < 8; i++) {
   PFont fonte= loadFont(nomeFonte);
   textFont(fonte,60);
   fill(255); 
  text(embaralhado[i], 64 + (i*70), 491); 
  }
  
}

// Apaga os quadrados da palavra embaralhada e resposta
void apagar() {
  int i = 0;
  posicaoAtual = 0;
  resposta = new char[0];
  for(i = 0; i < 8; i++) {
   fill(0);
     clicados[i] = 0;
     
    quad(56 + (70*i), 443, 112+(70*i), 443, 112+(70*i), 498, 56+(70*i), 498);
    quad(56 + (70*i), 373, 112+(70*i), 373, 112+(70*i), 428, 56+(70*i), 428);
  }
}


// Funcao que imprime na tela a palavra embaralhada
void carregaPalavra() {
// A distancia entre os quadrados eh 70 pixels comeca no 64x490
  PFont fonte= loadFont(nomeFonte);
  textFont(fonte,60);
  fill(255);
  int tam = tamBanco(); // pega o tamanho do banco de palavras
  String Pal = banco[tam-1]; // pega a maior palavra do banco
  int [] palavra = new int[Pal.length()];  // vetor de flags indicando qual letra ja foi escolhida randomicamente
  for(int i = 0; i < Pal.length(); i++) {
    palavra[i] = 0; 
  }
  
  int j;
  
  for(int i = 0; i < Pal.length(); i++ ) {
    // escolhe a letra randomicamente
    j = int(random(0, Pal.length()));
    while(palavra[j] != 0) {
      j = int(random(0, Pal.length())); 
    }
    
    palavra[j] = 1; // marca a letra escolhida 
    embaralhado[i] = Pal.charAt(j); // coloca essa letra no vetor de chars que indica a palavra embaralhada
    text(Pal.charAt(j), 64 + (70 *i),491); // imprime o caractere na tela
  }
}

// Devolve o tamanho do banco utilizado atualmente
int tamBanco() {
  switch(inicial) {
    case 1:
      return 30;
    case 2:
      return 19;
    case 3:
      return 22;
    default:
      return 0;
  }   
}

// Devolve o banco de palavras a ser usado 
String [] iniciaBancoPalavras() {
  String [] banco = null;
  switch(inicial) { 
    case 1:
     banco = new String[30];
     banco[0] = "OCA";
     banco[1] = "CAO";
     banco[2] = "CHA";
     banco[3] = "ARO";
     banco[4] = "COR";
     banco[5] = "OCO";
     banco[6] = "COAR";
     banco[7] = "CORO";
     banco[8] = "CARO";
     banco[9] = "ROCA";
     banco[10] = "CACO";
     banco[11] = "ORAR";
     banco[12] = "RARO";
     banco[13] = "HORA";
     banco[14] = "COCO";
     banco[15] = "ORCA";
     banco[16] = "CHAO";
     banco[17] = "ARCO";
     banco[18] = "CARRO";
     banco[19] = "COCAR";
     banco[20] = "COROA";
     banco[21] = "CORAR";
     banco[22] = "CACHO";
     banco[23] = "CHORO";
     banco[24] = "ROCHA";
     banco[25] = "CHOCAR";
     banco[26] = "COROAR";
     banco[27] = "CHARCO";
     banco[28] = "CHORAR";
     banco[29] = "CACHORRO";
     break;
    case 2:
     banco = new String[19];
     banco[0] = "TIO";
     banco[1] = "VOO";
     banco[2] = "BOI";
     banco[3] = "OVO";
     banco[4] = "BOTE";
     banco[5] = "BOTO";
     banco[6] = "VOTO";
     banco[7] = "BOJO";
     banco[8] = "OITO";
     banco[9] = "VETO";
     banco[10] = "VEIO";
     banco[11] = "OBOE";
     banco[12] = "JOIO";
     banco[13] = "JEITO";
     banco[14] = "BEIJO";
     banco[15] = "OBVIO";
     banco[16] = "OBITO";
     banco[17] = "OBJETO";
     banco[18] = "OBJETIVO";
     break;
    case 3:
     banco = new String[22];
     banco[0] = "IDA";
     banco[1] = "ANU";
     banco[2] = "DIA";
     banco[3] = "CEU";
     banco[4] = "NUA";
     banco[5] = "DAI";
     banco[6] = "ECA";
     banco[7] = "AUE";
     banco[8] = "NAU";
     banco[9] = "INCA";
     banco[10] = "DUNA";
     banco[11] = "CENA";
     banco[12] = "CEIA";
     banco[13] = "NUCA";
     banco[14] = "ACNE";
     banco[15] = "CADE";
     banco[16] = "CUIA";
     banco[17] = "NUNCA";
     banco[18] = "UNIDA";
     banco[19] = "UNICA";
     banco[20] = "NUANCE";
     banco[21] = "DENUNCIA";
     break;
  }
 return banco;
} 

// Imprime na tela os quadrados de todas as respostas possiveis
void iniciaPalavra() {
  //Dependendo de qual for o banco escolhido desenha o numero de respostas de cada tamanho de palavra
  switch(inicial){
    case 1:
      desenhaQuad(3, 6);
      desenhaQuad(4, 12);
      desenhaQuad(5, 7);
      desenhaQuad(6, 4);    
      desenhaQuad(8, 1);
      break;
    case 2:      
      desenhaQuad(3, 4);
      desenhaQuad(4, 9);
      desenhaQuad(5, 4);
      desenhaQuad(6, 1);
      desenhaQuad(8, 1);
      break;
    case 3:
      desenhaQuad(3, 9);
      desenhaQuad(4, 8);
      desenhaQuad(5, 3);
      desenhaQuad(6, 1);
      desenhaQuad(8, 1);
      break;
  }
}

// Desenha os quadrados na tela, recebe o numero de letras da palavra e numero de respostas que tem com aquele numero de letras
void desenhaQuad(int nLetras, int nVezes) {
   int i, j;
   int x = quadX;
   // comeca a desenhar quadrados a partir do 50 80
   // segunda coluna comeca em 300
   // terceira coluna comeca em 560
   // os quadrados de tamanho 20
   // espacamento entre quadrados eh de 4 pixels
   // espacamento entre linhas eh 6 pixels
   
   // itera no numero de respostas com aquele numero de letras
   for(i = 0; i < nVezes; i++) {
     // imprime quadrados com o tanto de letras dado
     for (j = 0; j < nLetras; j++) {
       // imprime um quadrado de tamanho 20x20 e depois pula 4 pixels de espaco para o prox quadrado
       quad(quadX, quadY, quadX + 20, quadY, quadX + 20, quadY + 20,quadX, quadY + 20);
       quadX = quadX + 24;
     }
     quadX = x; //pega o valor da coluna atual
     quadY = quadY + 26; // pula a linha para a proxima palavra
     if(quadY > 330) { // caso chegou no fim da coluna recomeca na outra coluna
       if(quadX == 50) {
          x = 300;
         quadX = 300; 
       } else {
          x = 560;
         quadX = 560; 
       }
       quadY = 80;
     }
   }  
}
